import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class WallFollower extends RobotController{
    private boolean turning;
    public WallFollower(){
		/**
	     * This controller "polls" (I.E. manually checks) all of its sensors and then
		 * makes an action choice based on what it sees.  The wait time is the amount of time
		 * that elapses between every cycle of check/execute.  It is measured in miliseconds and
		 * is set by changing the number in the setWaitTime(number) command below.  Currently it is
		 * set to 5... which means a sensor check/action decision is done every 5 miliseconds.  You 
		 * can change this if you want... but if you make it too long... the robot could crash into
		 * something while the controller is waiting to do its next sensor check.  Remember, unless you
		 * stop them... the motors will keep on doing what you tell them.
	     */
		setWaitTime(5);
        turning = false;
	}
	
	/**
	 * This method will be called after this controller has been started 
	 * and then again every so often until you stop the controller.  Specifically, it will be called
	 * once every how ever many miliseconds you specified in the call to setWaitTime()
	 */
	public void doWork() throws Exception {
            if(getDistanceValue(3) <= 10 && getDistanceValue(4) <= 10 && getDistanceValue(2) <= 10){
                System.out.println("Rett");
                System.out.println("0: " + getDistanceValue(0));
                System.out.println("1: " + getDistanceValue(1));
                System.out.println("2: " + getDistanceValue(2));
                System.out.println("3: " + getDistanceValue(3));
                System.out.println("4: " + getDistanceValue(4));
                System.out.println("5: " + getDistanceValue(5));
                System.out.println("6: " + getDistanceValue(6));
                System.out.println("7: " + getDistanceValue(7));
                goStraight();
            } else {
                turnRight();
            }
	}
	
	public void close() throws Exception{}
	
	public void stop(){
		setMotorSpeeds(0,0);
	}
	
	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight(){
		setMotorSpeeds(2,-2);
	}
	
	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft(){
		setMotorSpeeds(-2,2);
	}
	
	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight(){
		setMotorSpeeds(2,2);
	}
	
	protected void setFinished(boolean finished){
		super.setFinished(finished);
	}

}
