import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class Wall extends RobotController{
	private boolean wallFound = false;
	public final int WALL_CLOSE = 200;
	public final int LIGHT = 100;
	private Channel ch;

	public Wall(){
			/**
		     * This controller "polls" (I.E. manually checks) all of its sensors and then
			 * makes an action choice based on what it sees.  The wait time is the amount of time
			 * that elapses between every cycle of check/execute.  It is measured in miliseconds and
			 * is set by changing the number in the setWaitTime(number) command below.  Currently it is
			 * set to 5... which means a sensor check/action decision is done every 5 miliseconds.  You
			 * can change this if you want... but if you make it too long... the robot could crash into
			 * something while the controller is waiting to do its next sensor check.  Remember, unless you
			 * stop them... the motors will keep on doing what you tell them.
		     */
			setWaitTime(5);
			ch = new Channel(this);
			new Thread (ch).start();

		}

		/**
		 * This method will be called after this controller has been started
		 * and then again every so often until you stop the controller.  Specifically, it will be called
		 * once every how ever many miliseconds you specified in the call to setWaitTime()
		 */
		public void doWork() throws Exception {
			if(!wallFound){ //if ball not found, get closer
				moveToWall();
			}
		}

		public void close() throws Exception{}

		public void moveToWall(){


			if(ch.getState() == false){
				moveBack();
				turnRight();
				ch.sendStroke();
			}
			else if(ch.getLightValue(2)<LIGHT || ch.getLightValue(3)<LIGHT){
				turnRight();

			}else if(ch.getLightValue(3)<LIGHT || ch.getLightValue(4)<LIGHT){
				turnRight();

			}else if(ch.getLightValue(4)<LIGHT || ch.getLightValue(5)<LIGHT){
				turnLeft();

			}else if (ch.getDistanceValue(2)>WALL_CLOSE || ch.getDistanceValue(3)>WALL_CLOSE){
				turnRight();

			}else if (ch.getDistanceValue(3)>WALL_CLOSE || ch.getDistanceValue(4)>WALL_CLOSE){
				turnRight();

			}else if (ch.getDistanceValue(4)>WALL_CLOSE || ch.getDistanceValue(5)>WALL_CLOSE){
				turnLeft();

			}else if (ch.getDistanceValue(6)>WALL_CLOSE){
				turnRight();

			}else if (ch.getDistanceValue(1)>WALL_CLOSE){
				turnLeft();


			}else{
				goStraight();
			}

		}

		public void moveBack(){
			setMotorSpeeds(-7,-7);



		}


		/**
		 * This method will make the robot turn right.
		 */
		public void turnRight(){
			setMotorSpeeds(2,-2);
		}

		public void turnLeft(){
			setMotorSpeeds(-2,2);
		}



		/**
		 * This method will make the robot go straight ahead.
		 */
		public void goStraight(){
			setMotorSpeeds(2,2);
		}






}