import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class Task2Ch extends RobotController{

	private boolean complete = false;

	public final int BALL_CLOSE = 500; //distance sensor value
	public final int WALL_CLOSE = 300; //distance sensor value
	public final int LIGHT_VALUE = 500; //distance sensor value

	private Channel ch;

	public Task2Ch(){
		/**
	     * This controller "polls" (I.E. manually checks) all of its sensors and then
		 * makes an action choice based on what it sees.  The wait time is the amount of time
		 * that elapses between every cycle of check/execute.  It is measured in miliseconds and
		 * is set by changing the number in the setWaitTime(number) command below.  Currently it is
		 * set to 5... which means a sensor check/action decision is done every 5 miliseconds.  You
		 * can change this if you want... but if you make it too long... the robot could crash into
		 * something while the controller is waiting to do its next sensor check.  Remember, unless you
		 * stop them... the motors will keep on doing what you tell them.
	     */
		setWaitTime(5);

		ch = new Channel(this);
		new Thread(ch).start();

	}

	/**
	 * This method will be called after this controller has been started
	 * and then again every so often until you stop the controller.  Specifically, it will be called
	 * once every how ever many miliseconds you specified in the call to setWaitTime()
	 */
	public void doWork() throws Exception {
		move();
	}

	public void close() throws Exception{}

	public void move(){
		/*
		if(getDistanceValue(2)>=BALL_CLOSE && getDistanceValue(3)<=BALL_CLOSE){
			turnLeft();
		}else if(getDistanceValue(2)<=BALL_CLOSE && getDistanceValue(3)>=BALL_CLOSE){
			turnRight();
		}else if (getDistanceValue(2)>BALL_CLOSE && getDistanceValue(3)>BALL_CLOSE){
			stop();
			ballFound = true;
		}else{
			goStraight();
		}
		*/

		if(getLightValue(2)<=LIGHT_VALUE || getLightValue(3)<=LIGHT_VALUE){
			// Lysdeteksjon
			turnLeft();
		}else if(getLightValue(4)<=LIGHT_VALUE || getLightValue(5)<=LIGHT_VALUE){
			turnRight();
		}else if(ch.getDistanceValue(2)>=WALL_CLOSE || ch.getDistanceValue(3)>=WALL_CLOSE){
			// Kantdeteksjon
			turnLeft();
		}else if(ch.getDistanceValue(4)>=WALL_CLOSE || ch.getDistanceValue(5)>=WALL_CLOSE){
			// Kantdeteksjon
			turnLeft();
		} else {
			goStraight();
		}

	}

	public void stop(){
		setMotorSpeeds(0,0);
	}

	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight(){
		setMotorSpeeds(2,-2);
	}

	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft(){
		setMotorSpeeds(-2,2);
	}

	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight(){
		// Lagt inn funksjonalitet for "erratic movements"
		setMotorSpeeds((int)(Math.random()*10),(int)(Math.random()*10));
	}

	/**
	 * This method will make the robot pick up a ball if it's close enough.
	 */
	public void pickUpBall(){
		setGripperState(KSGripperStates.GRIP_OPEN); // Open gripper
		setArmState(KSGripperStates.ARM_DOWN); // Lower arms;
		sleep(100);		// wait 100ms
		setGripperState(KSGripperStates.GRIP_CLOSED); // Close gripper
		sleep(100);		// wait 100ms
		setArmState(KSGripperStates.ARM_UP); // lift arms;
		sleep(100);		// wait 100ms
	}

	protected void setFinished(boolean finished){
		super.setFinished(finished);
	}

}
