import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class Task3  extends RobotController{

	private boolean ballFound = false;
	private boolean backUp = false;
	private int		bpTimer;

	private int WAITTIME = 5;
	private int TIMEOUT = 5000;

	public final int BALL_CLOSE = 500; //distance sensor value
	private Channel ch;
	private Watchdog wc;

	public Task3(){
		/**
	     * This controller "polls" (I.E. manually checks) all of its sensors and then
		 * makes an action choice based on what it sees.  The wait time is the amount of time
		 * that elapses between every cycle of check/execute.  It is measured in miliseconds and
		 * is set by changing the number in the setWaitTime(number) command below.  Currently it is
		 * set to 5... which means a sensor check/action decision is done every 5 miliseconds.  You
		 * can change this if you want... but if you make it too long... the robot could crash into
		 * something while the controller is waiting to do its next sensor check.  Remember, unless you
		 * stop them... the motors will keep on doing what you tell them.
	     */
		setWaitTime(WAITTIME);
		wc = new Watchdog(TIMEOUT);
		ch = new Channel(this,wc);
		new Thread(ch).start();


	}

	/**
	 * This method will be called after this controller has been started
	 * and then again every so often until you stop the controller.  Specifically, it will be called
	 * once every how ever many miliseconds you specified in the call to setWaitTime()
	 */
	public void doWork() throws Exception {
		if(!wc.getState())
			backUp = true;
		if(backUp) {
			setMotorSpeeds(-2,-2); //Drive backwards to get out of the mess.
			bpTimer += WAITTIME;
			if(bpTimer > 500)
				backUp = false;
		} else {

			if(ch.getDistanceValue(3) > 1020 || ch.getDistanceValue(2) > 1020 ||  ch.getDistanceValue(1) > 1020) // Setter disse hyt for  fremprovosere feil
				turnRight();
			else
				goStraight();
			//turnRight();
		}

	}


	public void close() throws Exception{}


	public void stop(){
		setMotorSpeeds(0,0);
	}

	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight(){
		setMotorSpeeds(2,-2);
	}

	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft(){
		setMotorSpeeds(-2,2);
	}

	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight(){
		setMotorSpeeds(2,2);
	}

	/**
	 * This method will make the robot pick up a ball if it's close enough.
	 */
	public void pickUpBall(){
		setGripperState(KSGripperStates.GRIP_OPEN); // Open gripper
		setArmState(KSGripperStates.ARM_DOWN); // Lower arms;
		sleep(100);		// wait 100ms
		setGripperState(KSGripperStates.GRIP_CLOSED); // Close gripper
		sleep(100);		// wait 100ms
		setArmState(KSGripperStates.ARM_UP); // lift arms;
		sleep(100);		// wait 100ms
	}

	protected void setFinished(boolean finished){
		super.setFinished(finished);
	}

}
