import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class Task4 extends RobotController 
{

	public static final int VEGG_TRESHOLD = 10;
	public static final int LYS_TRESHOLD = 200;
	public static final int FRAM = 0;
	public static final int TILBAKE = 1;
	public static final int VENSTRE = 2;
	public static final int HOYRE = 3;
	private int teller;
	private int last;
	private boolean ballFunnet;
	private Channel ch;

	public Task4() 
	{
		setWaitTime(5);
		last = FRAM;
		ballFunnet = false;
		ch = new Channel(this);
		new Thread(ch).start();
	}

	public void doWork() throws Exception 
	{
		
		while(true) 
		{
			if (!erLysFram() && erLysVenstre() && erLysHoyre())
				last = FRAM;
			else if(hentSumFram() < hentSumVenstre() && hentSumFram() < hentSumHoyre())
				last = FRAM; 
			else if (erVeggFram() && (hentSumFram() > hentSumVenstre() || hentSumFram() > hentSumHoyre())) {
				if (hentSumVenstre() > hentSumHoyre())
					last = HOYRE;
				else
					last = VENSTRE;
			} else
				last = FRAM;
			switch(last) 
			{
				case FRAM:
					goStraight();
					break;
				case TILBAKE:
					backStep();
					break;
				case VENSTRE:
					turnLeft();
					break;
				case HOYRE:
					turnRight();
					break;
			}
			//System.out.println(teller);
		}
		//setFinished(true);
	}

	public void pickUpBall()
	{
		setGripperState(KSGripperStates.GRIP_OPEN); // Open gripper
		setArmState(KSGripperStates.ARM_DOWN); // Lower arms;
		sleep(100);		// wait 100ms
		setGripperState(KSGripperStates.GRIP_CLOSED); // Close gripper
		sleep(100);		// wait 100ms
		setArmState(KSGripperStates.ARM_UP); // lift arms;
		sleep(100);		// wait 100ms
	}

	private int hentSumFram() 
	{
		return ch.getLightValue(3) + ch.getLightValue(2) + ch.getDistanceValue(3) / 2 + ch.getDistanceValue(2) / 2;
	}

	private int hentSumBak() 
	{
		return ch.getLightValue(6) + ch.getLightValue(7) + ch.getDistanceValue(6) / 2 + ch.getDistanceValue(7) / 2;
	}

	private int hentSumVenstre() 
	{
		return ch.getLightValue(1) + ch.getLightValue(0) + ch.getDistanceValue(1) / 2 + ch.getDistanceValue(0) / 2;
	}

	private int hentSumHoyre() 
	{
		return ch.getLightValue(5) + ch.getLightValue(4) + ch.getDistanceValue(5) / 2 + ch.getDistanceValue(4) / 2;
	}

	private boolean erLysFram() 
	{
		if (ch.getLightValue(3) <= LYS_TRESHOLD || ch.getLightValue(2) <= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erLysBak() 
	{
		if (ch.getLightValue(6) <= LYS_TRESHOLD || ch.getLightValue(7) <= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erLysVenstre() 
	{
		if (ch.getLightValue(1) <= LYS_TRESHOLD || ch.getLightValue(0) <= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erLysHoyre() 
	{
		if (ch.getLightValue(5) <= LYS_TRESHOLD || ch.getLightValue(4) <= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erVeggFram() 
	{
		if (ch.getDistanceValue(3) >= LYS_TRESHOLD || ch.getDistanceValue(2) >= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erVeggBak() 
	{
		if (ch.getDistanceValue(6) >= LYS_TRESHOLD || ch.getDistanceValue(7) >= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erVeggVenstre() 
	{
		if (ch.getDistanceValue(1) >= LYS_TRESHOLD || ch.getDistanceValue(0) >= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	private boolean erVeggHoyre() 
	{
		if (ch.getDistanceValue(5) >= LYS_TRESHOLD || ch.getDistanceValue(4) >= LYS_TRESHOLD)
			return true;
		else
			return false;
	}

	public void backStep() 
	{
		setMotorSpeeds(-4,-4);
	}

	public void stop()
	{
		setMotorSpeeds(0,0);
	}
	
	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight()
	{
		setMotorSpeeds(4,-4);
		backStep();
		setMotorSpeeds(4,-4);
	}
	
	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft()
	{
		setMotorSpeeds(-4,4);
		backStep();
		setMotorSpeeds(-4,4);
	}
	
	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight()
	{
		setMotorSpeeds(4,4);
	}

	public void close() throws Exception{}

	protected void setFinished(boolean finished)
	{
		super.setFinished(finished);
	}

}


