
public class Watchdog {
	
	private long timelimit;
	private long lastStroke;
	
	/** 
	 * Constructs a watchdog with a specified timelimit
	 * @param timelimit watchdog state timelimit against the timebase
	 */
	public Watchdog(long timelimit){
		this.timelimit = timelimit;
		lastStroke = System.currentTimeMillis();
	}
	
	/**
	 * Stroke the watchdog.
	 */	
	public void stroke(){
		lastStroke = System.currentTimeMillis();
	}
	
	/**
	 * Get the watchdog state
	 * @return true if stoke is present within the timelimit, false if not.
	 */
	public boolean getState(){
		return System.currentTimeMillis() - lastStroke <= timelimit;
	}

}
